#include<bits/stdc++.h>
#define MAXN 500007
using namespace std;

struct hill{
    int l,r;
    int id;

    inline friend bool operator < (hill fr,hill sc){
        return fr.l<sc.l;
    }
};

const int inf=1e9+7;

int n,k,h[MAXN];
long long t[MAXN],ans;

int previous_hill[MAXN],next_hill[MAXN];
hill s[MAXN];

vector<int> sol;

void calc_ranges(){
    for(int i=1;i<=n;i++){
        previous_hill[i]=1;
        next_hill[i]=n;

        for(int f=i+1;f<=n;f++){
            next_hill[i]=f;
            if(h[f]>=h[i])break;
        }

        for(int f=i-1;f>=1;f--){
            previous_hill[i]=f;
            if(h[f]>=h[i])break;
        }
    }
}

bool check(long long maxt,bool solution){

    int pt=0;
    for(int i=1;i<=n;i++){
        while(pt<n and t[pt+1]-t[i]<=maxt)pt++;
        s[i].r=min(next_hill[i],pt);
        s[i].id=i;
    }

    pt=n+1;
    for(int i=n;i>=1;i--){
        while(pt>1 and t[i]-t[pt-1]<=maxt)pt--;
        s[i].l=max(previous_hill[i],pt);
    }

    sort(s+1,s+n+1);
    s[n+1].l=n+1;

    int last=1,jump=0,res=0;

    for(int i=1;i<=n;i++){
        if(s[i].r>s[jump].r)jump=i;

        if(s[i+1].l>last){
            res++;
            last=s[jump].r+1;

            if(solution)sol.push_back(s[jump].id);
        }
    }

    return res<=k;
}

long long bin(){
    long long l=0,r=t[n]+5,mid;

    while(l+1<r){
        mid=(l+r)/2;

        if(check(mid,false)){
            r=mid;
        }else{
            l=mid;
        }
    }

    return r;
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>k;
    for(int i=1;i<=n;i++){
        cin>>h[i];
    }
    h[0]=h[n+1]=inf;

    for(int i=2;i<=n;i++){
        cin>>t[i];
        t[i]+=t[i-1];
    }

    calc_ranges();

    ans=bin();
    
    if(ans==t[n]+5){
        cout<<"-1\n";
        return 0;
    }

    check(ans,true);
    while(sol.size()<k)sol.push_back(n);

    cout<<ans<<"\n";
    for(int i:sol)cout<<i<<" ";
    cout<<"\n";

    return 0;
}