#include<bits/stdc++.h>
#define MAXN 500007
using namespace std;

struct hill{
    int l,r;
};

const int inf=1e9+7;

int n,k,h[MAXN];
long long t[MAXN],ans;

int previous_hill[MAXN],next_hill[MAXN];
hill s[MAXN];
vector<int> sol;
stack<int> st;

void calc_ranges(){
    st.push(0);

    for(int i=1;i<=n;i++){
        while(!st.empty() and h[i]>h[st.top()]){
            st.pop();
        }
        previous_hill[i]=st.top();
        st.push(i);
    }

    while(!st.empty())st.pop();

    st.push(n+1);
    for(int i=n;i>=1;i--){
        while(!st.empty() and h[i]>h[st.top()]){
            st.pop();
        }
        next_hill[i]=st.top();
        st.push(i);
    }
}

bool cross(hill fr,hill sc){
    if(fr.r+1<sc.l)return false;
    if(sc.r+1<fr.l)return false;

    return true;
}

bool check(int maxt,bool solution){

    for(int i=1;i<=n;i++){
        s[i].r=min(next_hill[i],i+maxt);
        s[i].l=max(previous_hill[i],i-maxt);
    }

    int prefix=1,suffix=n;
    for(int i=1;i<=n;i++){
        if(s[i].l<=1 and s[i].r>s[prefix].r)prefix=i;
        if(s[i].r>=n and s[i].l<s[suffix].l)suffix=i;
    }

    for(int i=1;i<=n;i++){
        if(s[i].l<=s[prefix].r+1 and s[i].r>=s[suffix].l-1){
            if(solution)sol={prefix,i,suffix};

            return true;
        }
    }

    return false;
}

int bin(){
    int l=0,r=n,mid;

    while(l+1<r){
        mid=(l+r)/2;

        if(check(mid,false)){
            r=mid;
        }else{
            l=mid;
        }
    }

    return r;
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>k;
    for(int i=1;i<=n;i++){
        cin>>h[i];
    }
    h[0]=h[n+1]=inf;

    for(int i=2;i<=n;i++){
        cin>>t[i];
        t[i]+=t[i-1];
    }

    calc_ranges();
    ans=bin();
    
    if(ans==n){
        cout<<"-1\n";
        return 0;
    }

    check(ans,true);
    while(sol.size()<k)sol.push_back(n);

    cout<<ans<<"\n";
    for(int i:sol)cout<<i<<" ";
    cout<<"\n";

    return 0;
}