#include<iostream>
#include<algorithm>
#include<assert.h>
#include<vector>
#define MAXN 500000
using namespace std;
int h[MAXN],t[MAXN];
int prvH[MAXN],nxtH[MAXN];
int prvT[MAXN],nxtT[MAXN];
int segs[MAXN],inds[MAXN];
bool ans[MAXN];
int check (long long int maxt, int n, int k) {
    int ind=0;
    long long int sum=0;
    for (int i=0; i<n; i++) {
        for (;;) {
            if (sum<=maxt) break;
            sum-=t[ind];
            ind++;
        }
        prvT[i]=ind;
        sum+=t[i];
    }
    ind=n-1; sum=0;
    for (int i=n-1; i>=0; i--) {
        for (;;) {
            if (sum<=maxt) break;
            ind--;
            sum-=t[ind];
        }
        nxtT[i]=ind;
        if (i>0) sum+=t[i-1];
    }
    for (int i=0; i<n; i++) {
        segs[i]=-1;
        ans[i]=false;
    }
    //cout << mid << endl ;
    for (int i=0; i<n; i++) {
        int st=max(prvH[i],prvT[i]),fin=min(nxtH[i],nxtT[i]);
        //cout << st+1 << " " << fin+1 << endl ;
        segs[st]=max(segs[st],fin);
        if (segs[st]==fin) inds[st]=i;
    }
    int cnt=0,curr=0;
    pair <int, int> best={-1, -1};
    for (int st=0; st<n; st++) {
        //cout << st+1 << " " << curr+1 << " " << best+1 << endl ;
        if (st>curr) {
            if (best.first<curr) return false;
            ans[best.second]=true;
            cnt++;
            if (cnt>k) break;
            curr=best.first+1;
            if (curr==n) break;
        }
        if (best.first<segs[st]) {
            best.first=segs[st];
            best.second=inds[st];
        }
        if (st==n-1) {
            if (best.first<curr) return false;
            ans[best.second]=true;
            cnt++;
            curr=best.first+1;
        }
    }
    if ((cnt<=k)&&(curr==n)) return cnt;
    return 1e9;
}
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n,k;
    assert(cin >> n >> k );
    assert((1<=k)&&(k<=n)&&(n<=MAXN));
    //assert(k<=3);
    for (int i=0; i<n; i++) {
        assert(cin >> h[i] );
        assert((1<=h[i])&&(h[i]<=1e9));
    }
    vector <int> bigger;
    for (int i=0; i<n; i++) {
        for (;;) {
            if ((bigger.empty()==true)||(h[bigger.back()]>=h[i])) break;
            bigger.pop_back();
        }
        if (bigger.empty()==true) prvH[i]=0;
        else prvH[i]=bigger.back();
        bigger.push_back(i);
    }
    bigger.clear();
    for (int i=n-1; i>=0; i--) {
        for (;;) {
            if ((bigger.empty()==true)||(h[bigger.back()]>=h[i])) break;
            bigger.pop_back();
        }
        if (bigger.empty()==true) nxtH[i]=n-1;
        else nxtH[i]=bigger.back();
        bigger.push_back(i);
    }
    /*if ((n!=200)&&(n!=1500)) {
        for (int i=0; i<n; i++) {
            assert(nxtH[i]-prvH[i]+1<=101);
        }
    }*/

    for (int i=0; i<n-1; i++) {
        assert(cin >> t[i] );
        assert((1<=t[i])&&(t[i]<=1e9));
    }
    char temp; assert(!(cin >> temp ));

    long long int l=-1,r=n*1LL*1e9;
    for (;;) {
        if (l==r-1) break;
        long long int mid=(l+r)/2;
        if (check(mid,n,k)<=k) r=mid;
        else l=mid;
    }
    if (r==n*1e9) cout << -1 ;
    else {
        int cnt=check(r,n,k);
        cout << r << endl ;
        for (int i=0; i<n; i++) {
            if (ans[i]==true) cout << i+1 << " ";
        }
        for (int i=cnt+1; i<=k; i++) {
            cout << n << " ";
        }
    }
    cout << endl ;
    return 0;
}
